import React from 'react';
import './genericthumbnail.css';

interface GenericThumbnailProps {
    bodyText: string;
    bottomBannerText: string;
}

function GenericThumbnail(props: GenericThumbnailProps) {
    return (<div className='generic-thumbnail-container'>
        <div className="generic-thumbnail-container-upper">
            {props.bodyText}
        </div>
        <div className='generic-thumbnail-container-lower'>
            {props.bottomBannerText}
        </div>
    </div>);
}

export {GenericThumbnail}