import { findEndOfUnboundedList } from "./exponentialsearch";

test("9", async () => {
    const predicate = async (index: number) => {
        return index >= 0 && index <= 9;
    }

    expect(await findEndOfUnboundedList(0, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(1, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(2, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(3, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(4, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(5, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(6, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(7, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(8, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(9, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(10, predicate)).toBe(9);
    expect(await findEndOfUnboundedList(11, predicate)).toBe(9);
});

test("1", async () => {
    const predicate = async (index: number) => {
        return index >= 0 && index <= 1;
    }

    expect(await findEndOfUnboundedList(0, predicate)).toBe(1);
    expect(await findEndOfUnboundedList(1, predicate)).toBe(1);
});

test("0", async () => {
    const predicate = async (index: number) => {
        return index == 0;
    }

    expect(await findEndOfUnboundedList(0, predicate)).toBe(0);
});

test("none", async () => {
    const predicate = async (index: number) => {
        return false;
    }

    expect(await findEndOfUnboundedList(0, predicate)).toBe(0);
    expect(await findEndOfUnboundedList(1, predicate)).toBe(0);
    expect(await findEndOfUnboundedList(7, predicate)).toBe(0);
});

test("2", async () => {
    const predicate = async (index: number) => {
        return index >= 0 && index <= 2;
    }

    expect(await findEndOfUnboundedList(0, predicate)).toBe(2);
    expect(await findEndOfUnboundedList(1, predicate)).toBe(2);
    expect(await findEndOfUnboundedList(2, predicate)).toBe(2);
});

test('wait it works as a binary search?', async () => {
    const predicate = async (index: number) => {
        return index <= 6;
    }

    expect(await findEndOfUnboundedList(9, predicate)).toBe(6);
});