import {ObjectThumbnailUpdatePayload} from './components/thumbnails/objectthumbnail'


class ObjectState
{
  constructor(synchro: (pl: ObjectThumbnailUpdatePayload) => void) {
    this.synchronizerCallback = synchro;
  }

  private state = new ObjectThumbnailUpdatePayload();
  private synchronizerCallback = (pl: ObjectThumbnailUpdatePayload) => {};

  setSelected(sel: Boolean) {
    if(this.state.selected == sel) return;

    this.state.selected = sel;
    this.synchronizerCallback(this.state);
  }
}

export {ObjectState}