import { defineConfig } from 'vite'
import {resolve } from 'path'
import reactPlugin from '@vitejs/plugin-react'

// https://vitejs.dev/config/
export default defineConfig({
    plugins: [reactPlugin()],
    base: '',
    publicDir: 'public',
    build: {
        rollupOptions: {
            input: {
                main: resolve(__dirname, 'index.html'),
            }
        },
    },
})